SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderers'!

SW2Renderer subclass: #MARenderer
	instanceVariableNames: 'readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderers'!

MARenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderers'!

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/3/2005 16:30'!
renderConstituent: aDescription
	html divClass: 'constituent' with: [ super renderConstituent: aDescription ]. ! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/3/2005 15:48'!
renderDescription: aDescription
	html divClass: 'description' with: [ super renderDescription: aDescription ]. ! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 16:36'!
renderEditor: aDescription
	html divClass: 'editor' with: [ super renderEditor: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:26'!
renderLabel: aDescription
	html divClass: 'label' with: [ super renderLabel: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 16:36'!
renderViewer: aDescription
	html divClass: 'viewer' with: [ super renderViewer: aDescription ].! !

!MARenderer methodsFor: 'initialization' stamp: 'lr 3/3/2005 15:22'!
initialize
	super initialize.
	self readonly: false.! !

!MARenderer methodsFor: 'testing' stamp: 'lr 3/3/2005 15:19'!
isReadonly
	^self readonly.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/3/2005 15:19'!
readonly
	^readonly! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/3/2005 15:19'!
readonly: aBoolean
	readonly := aBoolean! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/3/2005 16:28'!
renderConstituent: aDescription
	(self isReadonly or: [ aDescription isReadonly ])
		ifTrue: [ self renderViewer: aDescription ]
		ifFalse: [ self renderEditor: aDescription ].! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/3/2005 16:29'!
renderDescription: aDescription
	self 
		renderLabel: aDescription; 
		renderConstituent: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:24'!
renderEditor: aDescription
	self component renderEditorOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:24'!
renderLabel: aDescription
	self component renderLabelOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:24'!
renderViewer: aDescription
	self component renderViewerOn: html.! !

!MARenderer methodsFor: 'visiting-description' stamp: 'lr 3/4/2005 01:06'!
visitComposedDescription: aDescription 
	(self isReadonly or: [ aDescription isReadonly ])
		ifTrue: [ self component renderViewerOn: html ]
		ifFalse: [ self component renderEditorOn: html ].! !

!MARenderer methodsFor: 'visiting-description' stamp: 'lr 3/3/2005 15:03'!
visitElementDescription: aDescription
	aDescription isVisible 
		ifTrue: [ self renderDescription: aDescription ].! !

MARenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderers'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/3/2005 16:28'!
renderConstituent: aDescription
	html tableData: [ super renderConstituent: aDescription ].! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/3/2005 15:39'!
renderDescription: aDescription
	html tableRow: [ super renderDescription: aDescription ].! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:47'!
renderLabel: aDescription
	html tableHeading: [ super renderLabel: aDescription ].! !

!MATableRenderer methodsFor: 'visiting-description' stamp: 'lr 3/3/2005 15:44'!
visitComposedDescription: aDescription 
	html table: [ super visitComposedDescription: aDescription ].! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/9/2005 22:28'!
asComponentOn: anObject
	^self componentClass model: anObject description: self.! !

WAComponent subclass: #MAComponent
	instanceVariableNames: 'model description renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComponent class methodsFor: 'accessing-defaults' stamp: 'lr 3/3/2005 15:51'!
defaultRenderer
	^SW2CssDescriptionRenderer new.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 11/28/2004 19:10'!
model: aModel
	^self model: aModel description: aModel description.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 20:20'!
model: aModel description: aDescription
	^self model: aModel description: aDescription renderer: self defaultRenderer.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 18:25'!
model: aModel description: aDescription renderer: aRenderer
	^self new
		model: aModel;
		description: aDescription;
		renderer: aRenderer;
		yourself.! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm
	self addForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm: aCollection
	self addDecoration: (WAFormDecoration new 
		buttons: aCollection;
		yourself).! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/3/2005 22:02'!
buildComponent: anObject
	^self buildComponent: anObject description: anObject description.! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/5/2005 20:18'!
buildComponent: anObject description: aDescription
	^(aDescription asComponentOn: anObject)
		renderer: self renderer;
		yourself.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
cancel
	self answer: nil.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:21'!
commit! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description
	^description! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description: anObject
	description := anObject! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model
	^model! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model: anObject
	model := anObject! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
refresh! !

!MAComponent methodsFor: 'rendering' stamp: 'lr 2/28/2005 16:14'!
renderContentOn: html
	self renderer in: self on: html visit: self description.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/4/2005 00:43'!
renderEditorOn: html 
	self subclassResponsibility.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 2/28/2005 16:14'!
renderLabelOn: html
	self description label isEmptyOrNil
		ifFalse: [ html render: self description label; text: ':' ].! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:18'!
renderViewerOn: html 
	html render: self cache.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/3/2005 16:16'!
renderer
	^renderer! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
renderer: aRenderer
	renderer := aRenderer.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
reset! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
save
	self commit; answer: self model.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
validate! !

MAComponent subclass: #MAElementComponent
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAElementComponent subclass: #MADateInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		dateInputWithValue: self cache 
		callback: (MessageSend 
			receiver: self 
			selector: #cache).! !

!MAElementComponent methodsFor: 'private' stamp: 'lr 3/9/2005 22:21'!
buildCache
	^self description model: self model.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:20'!
cache
	cache isNil
		ifTrue: [ self cache: self buildCache ].
	^cache.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:20'!
cache: anObject
	cache := anObject! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
commit
	super commit.
	self description isReadonly 
		ifTrue: [ ^self ].
	self description 
		model: self model
		set: self cache.! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
reset
	super reset.
	self cache: nil.! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
validate
	super validate.
	self description coerce: self cache.! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderEditorOn: html 
	html attributes: self description attributes.
	html fileUploadWithCallback: [ :file | self cache: file ].! !

MAElementComponent subclass: #MAOptionsComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAOptionsComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:00'!
renderEditorOn: html
	self 
		renderList: self description options
		selected: self cache
		callback: [ :value | self cache: value ]
		labels: self description labelBlock
		on: html.! !

!MAOptionsComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 21:59'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	self subclassResponsibility.! !

MAOptionsComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	html radioGroup in: [ :group |
		aCollection do: [ :each |
			html label: [
				html attributes: self description attributes.
				html 
					radioButtonInGroup: group
					selected: each = anObject
					callback: [ aCallbackBlock value: each ].
				html render: (aLabelBlock value: each) ] ] ].! !

MAOptionsComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	html attributes: self description attributes.
	html 
		selectFromList: aCollection
		selected: anObject
		callback: aCallbackBlock
		labels: aLabelBlock.! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:17'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textAreaOn: #cache of: self.! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:17'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textInputOn: #cache of: self.! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textPasswordOn: #cache of: self.! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:17'!
renderViewerOn: html 
	html render: (String new: self cache withAll: $*).! !

MAElementComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:17'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		timeInputWithValue: self cache 
		callback: (MessageSend 
			receiver: self 
			selector: #cache).! !

!Object methodsFor: '*Magritte-Seaside' stamp: 'lr 3/9/2005 22:25'!
asComponent
	"Return a generic Seaside component of the receiver."

	^self description asComponentOn: self.! !
